﻿Public Class Form1
    Structure TypeEmployee
        Dim number As Integer
        Dim name As String
        Dim division As String
        Dim salary As Integer
    End Structure

    Const fileName As String = "employee.txt"
    Dim employeeData() As TypeEmployee = New TypeEmployee() {}

    Dim fileObj As ReadWriteFile = New ReadWriteFile()  '*** 追加 ***

    Private Sub Form1_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

        If System.IO.File.Exists(fileName) Then
            'Dim s As String = System.IO.File.ReadAllText(fileName, _
            '  System.Text.Encoding.GetEncoding("Shift_JIS"))

            Dim s As String = fileObj.ReadFile(fileName)    '*** 追加 ***

            If s <> "" Then
                Dim lineCounter As Integer = s.Length - _
                  s.Replace(vbCrLf, vbCr).Length
                If lineCounter Mod 4 <> 0 Then
                    MessageBox.Show(fileName & "の行数が4で割り切れません")
                Else
                    Dim stringArray As String() = Split(s, vbCrLf)
                    ReDim employeeData(lineCounter \ 4 - 1)
                    For i As Integer = 0 To lineCounter - 1 Step 4
                        employeeData(i / 4).number = CInt(stringArray(i))
                        employeeData(i / 4).name = stringArray(i + 1)
                        employeeData(i / 4).division = stringArray(i + 2)
                        employeeData(i / 4).salary = CInt(stringArray(i + 3))
                        AddEmployeeDataToListBox(employeeData(i / 4))
                    Next
                End If
            End If
        End If
        UpdateLabelNumberOfEmployee()
    End Sub

    Private Sub UpdateLabelNumberOfEmployee()
        LabelNumberOfEmployee.Text = "登録済みデータは" & _
          CStr(employeeData.Length) & "件です"
    End Sub

    Private Sub AddEmployeeDataToListBox(ByVal emp As TypeEmployee)
        ListBoxMain.Items.Add(emp.number & "番" & " " & emp.name & _
          " " & emp.division & " " & emp.salary & "万円")
    End Sub

    Private Sub ButtonEnter_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles ButtonEnter.Click

        If BoxNumber.Text = "" OrElse BoxName.Text = "" OrElse _
          BoxDivision.Text = "" OrElse BoxSalary.Text = "" Then

            MessageBox.Show( _
              "すべての欄にデータを入力してから登録してください")
            Exit Sub
        End If

        Dim emp As TypeEmployee
        Try
            With emp
                .number = CInt(BoxNumber.Text)
                .name = BoxName.Text
                .division = BoxDivision.Text
                .salary = CInt(BoxSalary.Text)
            End With

        Catch ex As InvalidCastException
            MessageBox.Show( _
              "社員番号と年収の欄には半角数字を入力してください", _
              "エラー！", MessageBoxButtons.OK, _
              MessageBoxIcon.Exclamation)
            Exit Sub

        Catch ex As OverflowException
            MessageBox.Show( _
              "数が大き過ぎます", "エラー！", MessageBoxButtons.OK, _
              MessageBoxIcon.Exclamation)
            Exit Sub
        End Try

        For Each elementEmployee As TypeEmployee In employeeData
            If elementEmployee.number = emp.number Then
                MessageBox.Show("社員番号が重複しています！")
                Exit Sub
            End If
        Next

        ReDim Preserve employeeData(employeeData.GetUpperBound(0) + 1)
        employeeData(employeeData.GetUpperBound(0)) = emp
        AddEmployeeDataToListBox(emp)

        BoxNumber.Clear()
        BoxName.Clear()
        BoxDivision.Clear()
        BoxSalary.Clear()
        UpdateLabelNumberOfEmployee()
    End Sub

    Private Sub ButtonErase_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles ButtonErase.Click

        Dim index As Integer = ListBoxMain.SelectedIndex
        If index >= 0 Then
            For i As Integer = index To (employeeData.GetUpperBound(0) - 1)
                employeeData(i) = employeeData(i + 1)
            Next
            ReDim Preserve employeeData(employeeData.GetUpperBound(0) - 1)
            ListBoxMain.Items.RemoveAt(index)
            UpdateLabelNumberOfEmployee()
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, _
      ByVal e As System.Windows.Forms.FormClosingEventArgs) _
      Handles MyBase.FormClosing

        If employeeData.Length > 0 Then
            Dim s As String = ""
            For Each elementEmployee As TypeEmployee In employeeData
                With elementEmployee
                    s = s & .number & vbCrLf & .name & vbCrLf & .division _
                      & vbCrLf & .salary & vbCrLf
                End With
            Next
            'System.IO.File.WriteAllText(fileName, s, _
            '  System.Text.Encoding.GetEncoding("Shift_JIS"))

            fileObj.WriteFile(fileName, s)  '*** 追加 ***
        End If
    End Sub
End Class
